package po

import (
	"fmt"
	"gitea.cdlsxd.cn/sdk/plugin/proto"
	"plugins/alipay_cpn/internal/vo"
)

type OrderReq struct {
	UserId     string `json:"user_id"`
	LogonId    string `json:"logon_id"`
	PhoneId    string `json:"phone_id"`
	ActivityId string `json:"activity_id"`
	OutBizNo   string `validate:"required" json:"out_biz_no"`
}

type OrderResponse struct {
	Code    vo.Code `json:"code"`
	Msg     string  `json:"msg"`
	SubCode string  `json:"sub_code"`
	SubMsg  string  `json:"sub_msg"`

	ActivityOrderId      string `json:"activity_order_id"`
	ActivityId           string `json:"activity_id"`
	SendStatus           string `json:"send_status"`
	DiscountType         string `json:"discount_type"`
	DiscountThresholdAmt int32  `json:"discount_threshold_amt"`
	DiscountValue        int32  `json:"discount_value"`
	SendAmount           int32  `json:"send_amount"`
	VoucherId            string `json:"voucher_id"`
}

type OrderResp struct {
	Response OrderResponse `json:"alipay_user_dtbankcust_channelvoucher_send_response"`
}

func (o *OrderResp) GetMsg() string {
	if o.Response.Code.IsSuccess() {
		return o.Response.Msg
	}
	return fmt.Sprintf(
		"code:[%s],msg:[%s],subCode:[%s],subMsg[%s]",
		o.Response.Code, o.Response.Msg, o.Response.SubCode, o.Response.SubMsg,
	)
}

func (o *OrderResp) GetOrderStatus() proto.Status {
	if o.Response.Code.IsSuccess() {
		return proto.Status_ING
	}
	return proto.Status_FAIL
}
