package vo

import "gitea.cdlsxd.cn/sdk/plugin/proto"

type AcquireSt string

const (
	AcquireStSuccess AcquireSt = "10000"
	AcquireStFail    AcquireSt = "20000"
)

var notifyOrderTextMap = map[AcquireSt]string{
	AcquireStSuccess: "赠送成功",
	AcquireStFail:    "赠送失败",
}

var notifyOrderStatusMap = map[AcquireSt]proto.Status{
	AcquireStSuccess: proto.Status_SUCCESS,
	AcquireStFail:    proto.Status_FAIL,
}

func (o AcquireSt) GetText() string {
	msg, ok := notifyOrderTextMap[o]
	if !ok {
		return ""
	}
	return msg
}

func (o AcquireSt) GetOrderStatus() proto.Status {
	if o == "" {
		return proto.Status_INVALID
	}
	if resultStatus, ok := notifyOrderStatusMap[o]; ok {
		return resultStatus
	}
	return proto.Status_FAIL
}
